﻿--[[Version:7.1.0_01]]--
--[[
    技能列表, 所有减伤技能都放在这里
    每一项的格式:
	[104773] = {phys = 0, magic = 0, all = 0.4}, -- 术士[不灭决心]
	
	[104773] 法术ID
	phys     物理减伤数值
	magic    法术减伤数值
	all      所有减伤数值
	
	所有减伤数值 存在的话，其它两项就可不填，若要结合其它方法运算的，必须不填    
    每一个百分比都可以是一个小于等于1的数值或者返回一个数值的函数(不会写函数的话就直接写数字就行了)
    
]]

local _, L = ...;

--[[ 法术列表 ]] --
local spellList = {

    --= GameVersion:7.1.0 =--
	
    -- 自身技能 --    
  	
	[642] = {phys = 0, magic = 0, all = 1}, -- 圣骑士[圣盾术]
	[183435] = {phys = 0, magic = 0, all = 0.3}, -- 圣骑士[报复]惩戒
	[205191] = {phys = 0.35, magic = 0, all = 0}, -- 圣骑士[以眼还眼]惩戒 天赋75
	
	[132403] = {phys = 0, magic = 0, 
	            all = function()
	            local Mastery = string.format("%.2f", select(1,GetMasteryEffect())); --获取精通，2小数位处理
				local nameSpell = select(1,GetSpellInfo(26573)); --根据ID获取法术名称[奉献]   
				local nameAura = select(1,UnitAura("player",nameSpell)); --获取buff [奉献] 的名称
				if nameAura == nameSpell then return ((Mastery*0.5)/100 + 0.25) +(((Mastery*0.5)/100 + 0.25)*0.2) end;  --在 [奉献] buff ，加成20%
				return (Mastery*0.5)/100 + 0.25;   --包括基础精通8%的一半4%在内，所以[正义盾击]从25%起计算，目前实测1%精通加成0.5%
	            end}, -- 圣骑士[正义盾击]防护 受精通加成
				
	[221885] = {phys = 0, magic = 0, 
	           all = function()
			   local nameTalent = select(2, GetTalentInfo(5,2,GetActiveSpecGroup())); --获取指定的天赋名称
			   local TrueFalseTalent = select(4, GetTalentInfo(5,2,GetActiveSpecGroup())); --指定的天赋是否已学习
			   local nameSpell = select(1,GetSpellInfo(204139)); --根据ID获取法术名称[圣堂骑士]  
			   if nameTalent == nameSpell and TrueFalseTalent == true then return 0.2 end; 
			   return 0;
			   end}, -- 圣骑士[神圣马驹]防护 需要天赋75 [圣堂骑士]
			   
	[31850] = {phys = 0, magic = 0, all = 0.2}, -- 圣骑士[炽热防御者]防护
	[86659] = {phys = 0, magic = 0, all = 0.5}, -- 圣骑士[远古列王守卫]防护
	[498] = {phys = 0, magic = 0, all = 0.2}, -- 圣骑士[圣佑术]神圣
	[108271] = {phys = 0, magic = 0, all = 0.4}, -- 萨满祭司[星界转移]

	[45242] = {phys = 0, magic = 0, 
	           all = function()
			   local nameSpell = select(1,GetSpellInfo(45242)); --根据ID获取法术名称[专注意志] 
			   local ValueBuff = select(17,UnitBuff("player",nameSpell)); --#2，动态获取buff层数
			   return (-ValueBuff)/100;  --去掉 负号及百分比处理	
			   end}, -- 牧师[专注意志]
			   
	[232698] = {phys = 0.1, magic = 0, all = 0}, -- 牧师[暗影形态]暗影
	[47585] = {phys = 0, magic = 0, all = 0.6}, -- 牧师[消散]暗影
    [22812] = {phys = 0, magic = 0, all = 0.2}, -- 德鲁伊[树皮术]恢复 守护 平衡
	[61336] = {phys = 0, magic = 0, all = 0.5}, -- 德鲁伊[生存本能]守护
	[192083] = {phys = 0, magic = 0.3, all = 0}, -- 德鲁伊[乌索尔的印记]守护
	-- [16931] = {phys = 0, magic = 0, all = 0.06}, -- 德鲁伊[厚皮]守护  被动
	[158792] = {phys = 0, magic = 0, all = 0.08}, -- 德鲁伊[粉碎]
	[45438] = {phys = 0, magic = 0, all = 1}, -- 法师[寒冰屏障]
	[110959] = {phys = 0, magic = 0, all = 0.6}, -- 法师[强化隐形术]奥术
	-- [30482] = {phys = 0.06, magic = 0, all = 0}, -- 法师[熔岩护甲]火焰  被动
	[31224] = {phys = 0, magic = 1, all = 0}, -- 潜行者[暗影斗篷]
	
    [1966] = {phys = 0, magic = 0, 
	          all = function()			 
			  local TrueFalseTalent = select(4, GetTalentInfo(4,2,GetActiveSpecGroup())); --指定的天赋是否已学习 [飘忽不定]
			  if  TrueFalseTalent == true then return 0.3 end;
			  return 0;
			  end}, -- 潜行者[佯攻]   需要天赋60 [飘忽不定] 

	[45182] = {phys = 0, magic = 0, all = 0.85}, -- 潜行者[装死]  天赋60
	[122783] = {phys = 0, magic = 0.6, all = 0}, -- 武僧[散魔功]   天赋75
--	[115176] = {phys = 0, magic = 0, all = 0.6}, -- 武僧[禅悟冥想]酒仙   无buff显示，暂无法监视
	[120954] = {phys = 0, magic = 0, all = 0.2}, -- 武僧[壮胆酒]酒仙
	[125565] = {phys = 0, magic = 0, all = 0.2}, -- 战士[挫志怒吼]防护 
	[23920] = {phys = 0, magic = 0.3, all = 0}, -- 战士[法术反射]防护
	[871] = {phys = 0, magic = 0, all = 0.4}, -- 战士[盾墙]防护
	[184364] = {phys = 0, magic = 0, all = 0.3}, -- 战士[狂怒回复]狂怒
	[118038] = {phys = 0, magic = 0, all = 0.3}, -- 战士[剑在人在]武器
	[197690] = {phys = 0, magic = 0, all = 0.2}, -- 战士[防御姿态]武器  天赋60
	[186265] = {phys = 0, magic = 0, all = 0.3}, -- 猎人[灵龟守护]
	[104773] = {phys = 0, magic = 0, all = 0.4}, -- 术士[不灭决心]
	[218256] = {phys = 0, magic = 0.3, all = 0}, -- 恶魔猎手[强化结界]复仇
	
    [203819] = {phys = function()
	            local Mastery = string.format("%.2f", select(1,GetMasteryEffect())); --获取精通，2小数位处理
				return Mastery/100 + 0.2;   --包括基础精通6%在内，所以[恶魔尖刺]从20%起计算，目前实测1%精通加成1%
				end, magic = 0, all = 0}, -- 恶魔猎手[恶魔尖刺]复仇

--	[203513] = {phys = 0, magic = 0.1, all = 0}, -- 恶魔猎手[恶魔结界]复仇  被动				
	[212800] = {phys = 0, magic = 0, all = 0.35}, -- 恶魔猎手[疾影]浩劫
	[196555] = {phys = 0, magic = 0, all = 1}, -- 恶魔猎手[虚空行走]浩劫 天赋104
	
	[48792] = {phys = 0, magic = 0, 
	            all = function()
				local nameSpell = select(1,GetSpellInfo(48792)); --根据ID获取法术名称[冰封之韧] 
				local ValueBuff = select(19,UnitBuff("player",nameSpell)); --#2，动态获取buff层数
				return (-ValueBuff)/100;  --去掉 负号及百分比处理				
				end},  -- 死亡骑士[冰封之韧] 0.3鲜血  0.2邪恶冰霜
	
	[207319] = {phys = 0, magic = 0, all = 0.9}, -- 死亡骑士[血肉之盾]邪恶
	
	[195181] = {phys = 0, magic = 0,  
	            all = function()
				local nameSpell = select(1,GetSpellInfo(195181)); --根据ID获取法术名称[白骨之盾] 
				local CountBuff = select(4,UnitBuff("player",nameSpell)); --#2，动态获取buff层数
				if CountBuff > 0 and CountBuff < 4 then return 0.05 end;  -- 3层，5%
				if CountBuff > 3 and CountBuff < 7 then return 0.03 end; -- 6层，3%
				if CountBuff > 6 then return 0.02 end;  -- 9-10层，2%				
				end},  -- 死亡骑士[白骨之盾]鲜血
	
--	[206967] = {phys = 0, magic = 0, all = 0.2}, -- 死亡骑士[大墓地意志]鲜血 天赋90  生命低于35%时,被动

	
	
    -- 团队技能 --    
	[204335] = {phys = 0, magic = 0, all = 0.2}, -- 圣骑士[圣光护盾]防护 天赋90
	
    [6940] = {phys = 0, magic = 0, 
	           all = function()
			   local nameSpell = select(1,GetSpellInfo(6940)); --根据ID获取法术名称[牺牲祝福]   
			   local CasterNameAura = select(8,UnitAura("player",nameSpell)); --获取buff [牺牲祝福] 的施法者
			   if CasterNameAura == "player" then return 0 end;  --要判断来源 !=自己
			   return 0.3;	
			   end}, -- 圣骑士[牺牲祝福]防护 神圣 
			   
	[1022] = {phys = 1, magic = 0, all = 0}, -- 圣骑士[保护祝福]
	[204018] = {phys = 0, magic = 1, all = 0}, -- 圣骑士[破咒祝福]防护 天赋60
	
    [210320] = {phys = 0, magic = 0, 
	            all = function()
				local nameSpell = select(1,GetSpellInfo(210320)); --根据ID获取法术名称[虔诚光环] 
				local ValueBuff = select(17,UnitBuff("player",nameSpell)); --#2，动态获取buff层数
				return (-ValueBuff)/100;  --去掉 负号及百分比处理
				end}, -- 圣骑士[虔诚光环]神圣 天赋60
	
    [183416] = {phys = 0, magic = 0, 
	           all = function()
			   local nameSpell = select(1,GetSpellInfo(183416)); --根据ID获取法术名称[牺牲光环]   
			   local CasterNameAura = select(8,UnitAura("player",nameSpell)); --获取buff [牺牲光环] 的施法者
			   if CasterNameAura == "player" then return 0 end;  --要判断来源 !=自己
			   return 0.1;			  
	           end}, -- 圣骑士[牺牲光环]神圣 天赋60 
	
	[33206] = {phys = 0, magic = 0, all = 0.4}, -- 牧师[痛苦压制]
	[81782] = {phys = 0, magic = 0, all = 0.25}, -- 牧师[真言术：障]
	[98007] = {phys = 0, magic = 0, all = 0.1}, -- 萨满祭司[灵魂链接图腾]恢复
	[53480] = {phys = 0, magic = 0, all = 0.2}, -- 猎人[牺牲咆哮] 宠物天赋狡诈提供
	[102342] = {phys = 0, magic = 0, all = 0.2}, -- 德鲁伊[铁木树皮]恢复
	[223658] = {phys = 0, magic = 0, all = 0.2}, -- 战士[捍卫]防护  天赋30   

};



--[[
   多个减伤技能同时存在的时候是做乘法

   减20%承受80%伤害 再减50%承受40%的最终伤害 减免伤害为60%
   减免伤害公式为 1-（1-0.2）*（1-0.5）

   承受伤害公式为 （1-0.2）*（1-0.5）

--]]


--[[ 计算模块 ]] --

local DogTag = LibStub("LibDogTag-3.0");

function Debug(thing)
    TMW:Print(thing)
end

DogTag:AddEventHandler( "Base", "UNIT_AURA", function( event, mobId )  --添加事件处理器
	DogTag:FireEvent( "DamageReduction" )
end)



-- 所有减伤计算 -- 
DogTag:AddTag("Base","AllDaRe", {
	code = function()
	    -- get buffs
        local i = 1;
        local percent = 1;
        local had = {};
        while 1 do
            local name, _, _, count, _, _, _, _, _, _, spellID, _, _ = UnitAura("player", i);  --获取玩家的buff
            -- Debug(name);
            if not name then break end;
             if spellList[spellID] and spellList[spellID].all and not (had[spellID] and not spellList[spellID].stack) then            		   
                had[spellID] = 1;
                if type(spellList[spellID].all) == "number" then                
					percent =  percent * (1-spellList[spellID].all); --仍要承受的伤害比例
                else                 
					percent = percent * (1-spellList[spellID].all());  --仍要承受的伤害比例.此为法术项内置判断计算
                end
            end
            i = i + 1;
        end
               
		return ((1-percent)*100); --减免伤害
	end,
    arg = {},
    ret = "string", 
	events = "DamageReduction",
	doc = L["AllDaReDoc"],
	example = '[AllDaRe] => "50"; [AllDaRe:Percent] => "50%"',
	category = L["category"]
});

-- 物理减伤计算 -- 
DogTag:AddTag("Base","PhysDaRe", {
	code = function()
	    -- get buffs
        local i = 1;
        local percent = 1;
        local had = {};
        while 1 do
            local name, _, _, count, _, _, _, _, _, _, spellID, _, _ = UnitAura("player", i);  --获取玩家的buff
            -- Debug(name);
            if not name then break end;
             if spellList[spellID] and spellList[spellID].phys and not (had[spellID] and not spellList[spellID].stack) then            		   
                had[spellID] = 1;
                if type(spellList[spellID].phys) == "number" then
                    percent = percent * (1-spellList[spellID].phys);     --仍要承受的伤害比例					
                else 
                    percent =  percent * (1-spellList[spellID].phys());     --仍要承受的伤害比例.此为法术项内置判断计算					
                end
            end
            i = i + 1;
        end
               
		return ((1-percent)*100); --减免伤害
	end,
    arg = {},
    ret = "string",
	events = "DamageReduction",
    doc = L["PhysDaReDoc"],
	example = '[PhysDaRe] => "50"; [PhysDaRe:Percent] => "50%"',
	category = L["category"]
});


-- 法术减伤计算 -- 
DogTag:AddTag("Base","MagicDaRe", {
	code = function()
	    -- get buffs
        local i = 1;
        local percent = 1;
        local had = {};
        while 1 do
            local name, _, _, count, _, _, _, _, _, _, spellID, _, _ = UnitAura("player", i);  --获取玩家的buff
            -- Debug(name);
            if not name then break end;
            if spellList[spellID] and spellList[spellID].magic and not (had[spellID] and not spellList[spellID].stack) then
                had[spellID] = 1;
                if type(spellList[spellID].magic) == "number" then
                    percent =  percent * (1-spellList[spellID].magic);     --仍要承受的伤害比例					
                else 
                    percent =  percent * (1-spellList[spellID].magic());     --仍要承受的伤害比例.此为法术项内置判断计算					
                end
            end
            i = i + 1;
        end
                
		return ((1-percent)*100); --减免伤害
	end,
    arg = {},
    ret = "string",
	events = "DamageReduction",
	doc = L["MagicDaReDoc"],
	example = '[MagicDaRe] => "50"; [MagicDaRe:Percent] => "50%"',	
	category = L["category"]
});