local currentSpec = GetSpecialization()  --返回玩家当前专精的索引
local currentSpecName = select(2, GetSpecializationInfo(currentSpec)) --返回玩家的专精信息，select选择第2项，即name
print("Your current spec:", currentSpecName)  --输出信息

--专精名称宏代码--
local currentSpec = GetSpecialization()local currentSpecName = select(2, GetSpecializationInfo(currentSpec))print("Your current spec:", currentSpecName)

-- 可获取指定天赋名称--
local nameTalent= select(2, GetTalentInfo(2,1,1))print("Your current Talent:", nameTalent)

--获取精通，2小数位处理--
print(string.format("%.2f", select(1,GetMasteryEffect())))  


------------------------------------
local nameAura = select(1,UnitAura("player","奉献"))  GetTalentInfo(4,2,GetActiveSpecGroup()))print(nameTalent)

local nameSpell,rank, fileId, castTime, minRange, maxRange, spellId = GetSpellInfo(132403) print(spellId)
local nn = select(1,GetSpellInfo(132403)) print(nn)
print(select(1,GetSpellInfo(132403))) local nameSpell = select(1,GetSpellInfo(183416)) print(nameSpell)
local CasterNameAura = select(16,UnitBuff("player","冰封之韧"))print(CasterNameAura)
local CasterNameAura = select(1,GetUnitName("player",false))print(CasterNameAura)

--[[ ==  GetSpellInfo()  ==   返回一个法术信息

   name, rank, fileId, castTime, minRange, maxRange, spellId = GetSpellInfo(spellId[spellName])

[] 可选参数


--参数--
spellId
整型 - 法术的惟一标识符.

或

spellName
字符串 - 法术的名称.

--返回--
name
字符串 - 法术的名称.
rank
字符串 - 法术的二级文本,显示在法术工具提示右上角. 如 “种族”，“战斗姿态”.
fileId
数字 -  图标纹理的文件Id.
castTime
数字 - 施法时间,以毫秒为单位.
minRange
数字 - 法术的最小范围(射程).
maxRange
数字 - 法术的最大范围(射程).
spellId
整型 - 法术的惟一标识符.

--例子--
聊天框输出法术信息

/run local nn = select(1,GetSpellInfo(132403)) print(nn)


]]--

--[[ ==  UnitAura()  ==   返回在指定单元的buff或者debuff的信息

   name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, canStealOrPurge, nameplateShowPersonal, spellId, canApplyAura, isBossDebuff, isCastByPlayer, nameplateShowAll, timeMod, ...    = UnitAura("unit", index[, "filter"])  or  UnitAura("unit", "name", "rank"[, "filter"])

   
[] 可选参数


--参数--
unit
字符串  - 查询光环的单位(unitId).
index or name
数字 or 字符串 - 索引 (从 1 到 40)或查询光环的名字.
rank
字符串(可选) - 查询光环的等级;只有结合名字可用.
filter
字符串(可选) - 过滤器列表,由空格或管道隔开. "HELPFUL" 默认.
  以下过滤器是可用的:
    HELPFUL - buffs.
    HARMFUL - debuffs.
    PLAYER - 光环所应用的玩家.
    RAID - 光环可以被应用(如果HELPFUL)或消除(如果HARMFUL)的玩家.
    CANCELABLE - buffs可以被删除(如单击右键或使用/cancelaura命令)
    NOT_CANCELABLE - buffs 不能被删除

	
--返回--
name 
字符串 - 光环名称
rank 
字符串 - 造成光环的法术或效果的等级,或空字符串如果没有等级
icon 
字符串 - 光环图标的纹理文件路径
count 
数字 - 光环已经应用到目标的次数,或0为不堆栈(stack)的光环.直接图标右下角的叠加数字
debuffType 
字符串 - 光环的类型 ("Magic", "Disease", "Poison", "Curse", 或一个空字符串激怒效果),或零 光环没有类型的
duration 
数字 - 光环的全部持续时间(s)
expirationTime 
数字 - 光环将到期的时间(s)  (可比较GetTime())  好像未格式化的时间
unitCaster 
字符串  - 施放光环的单位(unitId),或零 如果没有有效单位代表当前施法者
canStealOrPurge 
布尔值 - 真(true), buffs 可以被偷窃通过法师的[法术偷取], 假(false) debuffs 和 buffs不能被偷窃,或者是debuffs 
nameplateShowPersonal 
布尔值 - 真(true), buffs 应该显示在 玩家/宠物/载具 姓名板
spellId 
数字 - 法术ID 应用光环的法术或效果的
canApplyAura 
布尔值 - 真(true)，光环能应用于玩家(不一定 如果玩家应用光环,刚刚 如果玩家能应用光环)
isBossDebuff 
布尔值 - 真(true)，光环是由 boss 给的
isCastByPlayer 
布尔值 - 真(true)，光环是由 玩家 给的
nameplateShowAll 
布尔值 - 真(true)，光环应该是显示在所有姓名板
timeMod 
数字 - 剩余时间比例系数(似乎总是1;暴雪的显示代码是不正确的).
... 
额外的值相关的特定的光环(Hots,陷阱,等等。例如,第一个值为复仇是受其攻击强度加成)。


--例子--
UnitAura("target", 1) 
首个 buff 在目标

UnitAura("target", 1, "PLAYER HARMFUL") 
首个 debuff 玩家对目标施放的

UnitAura("player", "Renew") 
首个实例更新在玩家

UnitAura("player", "Renew", nil, "PLAYER") 
首个实例的更新施放通过玩家的玩家

下面的宏打印名字任何 stealable buffs 在当前目标,或一个通知 如果不在 stealable.
/run local y,n,s,_ for i=1,40 do n,_,_,_,_,_,_,_,s=UnitAura("target",i)if s then print(n.." on target, steal it!")y=1 end end if y~=1 then print("No stealable buffs.")end


注：
法术等级是在4补丁中移除（灾难），所以排名这个函数的参数是基本上无用的今天。
有些过滤器是互斥的。使用“有益有害”将不会返回任何结果，因为没有光环既可以是一个迷，同时一个debuff。使用“撤销not_cancelable”也将不会返回任何结果，因为没有黄色的既可以是可拆卸和不可拆卸。
这个debufftype返回值是没有本地化。
这个unitbuff函数是一个别名使用unitaura与“帮助”过滤器。这个unitdebuff函数是一个别名使用unitaura与“有害”的过滤器。两个别名会忽略“有益”和“有害”的过滤器，而接受其他的过滤器。
]]--

--[[ ==  UnitBuff()  ==   返回在指定单元的buff

   name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, nameplateShowPersonal, spellId, canApplyAura, isBossDebuff, nameplateShowAll, timeMod, value1, value2, value3 = UnitBuff("unit", index or "name"[, "rank"][, "filter"])

   
unit,index,filter
or
unit,name,rank,filter

[] 可选参数


--参数--
unit 
字符串 - 用来查询的 UnitId (如 "player", "party2", "pet", "target" 等等..)
index
数字 - buff索引 用来检索信息的. 从1开始,最大40.
filter
字符串(可选) - 过滤器列表,由空格或管道隔开. "HELPFUL" 默认.
  以下过滤器是可用的:
    HELPFUL - buffs.
    HARMFUL - debuffs.
    PLAYER - 光环所应用的玩家.
    RAID - 光环可以被应用(如果HELPFUL)或消除(如果HARMFUL)的玩家.
    CANCELABLE - buffs可以被删除(如单击右键或使用/cancelaura命令)
    NOT_CANCELABLE - buffs 不能被删除
	

--返回--
name
字符串 - buff的法术或效果的名称,或零 如果没有发现buff 在指定的名称或在指定的索引.当你鼠标移至buff图标时显示黄色的名称.
rank
字符串 - 造成buff的法术或效果的等级.返回""如果没有等级.
iconTexture
字符串 - (路径和文件名)指示buff的标识符的.
count
数字 - buff已经应用到目标的次数.直接图标右下角的叠加数字
debuffType
字符串 - buff的魔法类型
duration
数字 - buff的全部持续时间(s)
expirationTime
数字 - buff将到期的时间(s)
source
字符串 - 施放buff的单位
isStealable
布尔值 - 真(true) 如果是stealable
nameplateShowPersonal
布尔值 - 真(true) 如果buff应该是显示在 玩家/宠物/载具 姓名板
spellId
数字 - 光环的法术ID.
canApplyAura
布尔值 - 真(true)，光环能应用于玩家(不一定 如果玩家应用光环,刚刚 如果玩家能应用光环).
isBossDebuff
布尔值 - 真(true)，光环是由 boss 给的.
nameplateShowAll
布尔值 - 真(true)，光环应该是显示在所有姓名板
timeMod
数字 - 剩余时间比例系数
value1
数字 - 光环的变量值#1. (HoTs, 资源获取小饰品等.)
value2
数字 - 光环的变量值#2. (HoTs, 资源获取小饰品等.)
value3
数字 - 光环的变量值#3. (HoTs, 资源获取小饰品等.)


--例子--
获取buff名称
local CasterNameAura = select(1,UnitBuff("player","牺牲祝福"))print(CasterNameAura)

]]--

--[[ ==  UnitDebuff()  ==   返回在指定单元的debuff

   name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, nameplateShowPersonal, spellId, canApplyAura, isBossDebuff, nameplateShowAll, timeMod, value1, value2, value3 = UnitDebuff("unit", index or "name"[, "rank"][, "filter"])

   
unit,index,filter
or
unit,name,rank,filter

[] 可选参数


--参数--
unit 
字符串 - 用来查询的 UnitId (如 "player", "party2", "pet", "target" 等等..)
index
数字 - buff索引 用来检索信息的. 从1开始,最大40.
filter
字符串(可选) - 过滤器列表,由空格或管道隔开. "HELPFUL" 默认.
  以下过滤器是可用的:
    HELPFUL - buffs.
    HARMFUL - debuffs.
    PLAYER - 光环所应用的玩家.
    RAID - 光环可以被应用(如果HELPFUL)或消除(如果HARMFUL)的玩家.
    CANCELABLE - buffs可以被删除(如单击右键或使用/cancelaura命令)
    NOT_CANCELABLE - buffs 不能被删除
	

--返回--
name
字符串 - debuff的法术或效果的名称,或零 如果没有发现debuff 在指定的名称或在指定的索引.当你鼠标移至debuff图标时显示黄色的名称.
rank
字符串 - 造成debuff的法术或效果的等级.返回""如果没有等级.
icon
字符串 - (路径和文件名)指示debuff的标识符的，或零 如果没有debuff
count
数字 - debuff已经应用到目标的次数.直接图标右下角的叠加数字
debuffType
字符串 - debuff的魔法类型
duration
数字 - debuff的全部持续时间(s)
expirationTime
数字 - debuff将到期的时间(s)
unitCaster
String -unitIdreference to the unit that cast the buff/debuff.
isStealable
布尔值 - 真(true) 如果是stealable
nameplateShowPersonal
布尔值 - 真(true) 如果debuff应该是显示在 玩家/宠物/载具 姓名板
spellId
数字 - 光环的法术ID.
canApplyAura
布尔值 - 真(true)，光环能应用于玩家(不一定 如果玩家应用光环,刚刚 如果玩家能应用光环).
isBossDebuff
布尔值 - 真(true)，光环是由 boss 给的.
nameplateShowAll
布尔值 - 真(true)，光环应该是显示在所有姓名板
timeMod
数字 - 剩余时间比例系数
value1
数字 - 光环的变量值#1. (HoTs, 资源获取小饰品等.)
value2
数字 - 光环的变量值#2. (HoTs, 资源获取小饰品等.)
value3
数字 - 光环的变量值#3. (HoTs, 资源获取小饰品等.)


--例子--
获取buff名称
local CasterNameAura = select(1,UnitDebuff("player","牺牲祝福"))print(CasterNameAura)

]]--


--[[ ==  UnitId  ==  
"arenaN" 
Opposing arena member with index N (1,2,3,4 or 5).

"arenapetN" 
The pet of the Nth opposing arena member (N is 1,2,3,4 or 5).

"bossN" 
The active bosses of the current encounter if available N (1,2,3 or 4). (Added in 3.3.0)

"focus" 
The current player's focus target as selected by the /focus command. (Added in 2.0.0).

"mouseover" 
The unit which the mouse is currently (or was most recently) hovering over.

"none"
A valid unit token that always refers to no unit. UnitName will return "Unknown, nil" for this UnitID. Use to force a macro to not auto self-cast (/cast [target=none] Healing Wave).

"partyN" 
The Nth party member excluding the player (1,2,3 or 4).

"partypetN" 
The pet of the Nth party member (N is 1,2,3, or 4) (Added in 1.5.0).

"pet" 
The current player's pet.

"player" 
The current player.

"raidN" 
The raid member with raidIndex N (1,2,3,...,40).

"raidpetN" 
The pet of the raid member with raidIndex N (1,2,3,...,40) (Added in 1.5.0)

"target" 
The currently targeted unit. May be overridden in macros by unit specified as a value of respective Secure Button attribute.

"vehicle" 
The current player's vehicle.
------------------------------------------------------
"npc" 
The NPC with which the player is currently interacting. You must be interacting with the NPC for this to work (e.g. the quest, flight path, merchant, gossip, or bank frame is open).

player name 
As returned by UnitName, GetGuildRosterInfo, GetFriendInfo, COMBAT LOG EVENT, etc. This must be spelled exactly and will be invalid if the named player is not a part of your party or raid. As with all other UnitIDs, it is not case sensitive.

]]


--[[ ==  UnitName()  ==   返回指定单位的名称或服务器名称

   name, realm = UnitName("unit")

[] 可选参数


--参数--
unit 
字符串 - 用来查询的 UnitId (如 "player", "party2", "pet", "target" 等等..)


--返回--
name 
字符串 - 指定单位的名称, "nil" 如不适用(如,如果指定的单位是“target”,但玩家没有选择目标).
realm 
字符串 - 指定单位的服务器名称.如果来自你的服务器, 这 realm == nil (但第二返回值仍然存在). 

--例子--
聊天框输出玩家的名字
local playerName = UnitName("player");
ChatFrame1:AddMessage('Hi my name is: ' .. playerName);

]]--

--[[ ==  GetUnitName()  ==   返回指定单位的名称或服务器名称

   name = GetUnitName("unit", showServerName)

[] 可选参数


--参数--
unit 
字符串 - 用来查询的 UnitId (如 "player", "party2", "pet", "target" 等等..)
showServerName
布尔值 - 真(True)完整的服务器名称附加到单位来自其他服务器的; 假(false)附加一个短指示符. 

--返回--
name 
字符串 - 单位的名字(和可能的服务器名称),格式化每个指定的参数.


--例子--
聊天框输出玩家的名字
local playerName = GetUnitName("player");
ChatFrame1:AddMessage('Hi my name is: ' .. playerName);

]]--

--[[ ==  UnitClass()  ==   返回指定单位的职业

   localizedClass, englishClass, classIndex = UnitClass("unit");

[] 可选参数


--参数--
unit 
字符串 - 用来查询的 UnitId (如 "player", "party2", "pet", "target" 等等..)


--返回--
localizedclass
本地化职业字符串 指定单位的.如 "法师", "战士", 等等.
englishclass
全大写英语职业名没有空格,如 "MAGE", "WARRIOR", "DEATHKNIGHT", 等等.
classIndex
索引数字 对应返回的特定职业.
映射数字如下:
None = 0
Warrior = 1     --战士
Paladin = 2     --圣骑士
Hunter = 3      --猎人
Rogue = 4       --盗贼
Priest = 5      --牧师
DeathKnight = 6   --死亡骑士 
Shaman = 7        --萨满祭司
Mage = 8          --法师
Warlock = 9       --术士
Monk = 10         --武僧
Druid = 11        --德鲁伊


--例子--
聊天框输出玩家的职业
local playerClass, englishClass = UnitClass("player");
ChatFrame1:AddMessage('Your player is a : ' .. playerClass .. '; ' .. englishClass .. '.');


]]--



--[[  专精相关

--[[ ==  GetSpecialization()  ==   返回玩家当前专精的索引

   local currentSpec = GetSpecialization( [ isInspect [, isPet] [, specGroup] ] )

[] 可选参数


--参数--
isInspect
布尔值 - 如果为真(true),返回已检查玩家的信息
isPet
如果为真(true),返回已检查玩家宠物的信息
specGroup
数字 - 这索引是一个给定的专精/天赋/字形集(1 主要的 / 2 次要的).


--返回--
currentSpec
数字 - 当前专精的索引(从1开始), 或零 如果没有学习任何专精.

--例子--
下面的代码片段显示玩家当前的专精名字，如果你有一个选择。宏代码要在一行
/run local currentSpec = GetSpecialization()local currentSpecName = currentSpec and select(2, GetSpecializationInfo(currentSpec)) or "None"print("Your current spec:", currentSpecName)
]]--


--[[ ==  GetSpecializationInfo()  ==   返回玩家的专精信息

 local id, name, description, icon, background, role = GetSpecializationInfo(specIndex [, isInspect] [, isPet] [, ?] [, genderCode] )

[] 可选参数


--参数--
specIndex
数字 - 要查询的专精索引, 1 到 GetNumSpecializations() 获取的.
isInspect
可选布尔值 - 如果为真(true), 查询已检查单位的专精信息.
isPet
可选布尔值 - 如果为真(true), 查询已检查单位宠物的专精信息.
genderCode
数字 - 通过UnitSex()返回的索引.

--返回--
id
数字 - 专精ID.
name
字符串 - 专精名称, 如 "平衡".
description
字符串 - 专精描述, 如 "可以采取的形式在一个强大的枭兽,自然平衡的神秘的力量和魔法摧毁敌人在远处."
icon
字符串 - 纹理路径这个专精的图标.
background
字符串 - 这个天赋树的背景纹理名称; 前置 "Interface\TALENTFRAME\"的值为一个有效的纹理路径.
role
字符串 - 这个专精在一个队伍中的作用,“伤害输出”,“坦克”,“治疗” 之一.

]]--

--[[ ==  GetSpecializationInfoByID()  ==   返回玩家的专精信息(ID)

 local id, name, description, icon, background, role, class   = GetSpecializationInfoByID(specializationID)
 
[] 可选参数


--参数--
specializationID
数字 - 这ID来自 GetSpecializationInfo().


--返回--
id
数字 - 专精ID.
name
字符串 - 专精名称, 如 "平衡".
description
字符串 - 专精描述, 如 "可以采取的形式在一个强大的枭兽,自然平衡的神秘的力量和魔法摧毁敌人在远处."
icon
字符串 - 纹理路径这个专精的图标.
background
字符串 - 这个天赋树的背景纹理名称; 前置 "Interface\TALENTFRAME\"的值为一个有效的纹理路径.
role
字符串 - 这个专精在一个队伍中的作用,“伤害输出”,“坦克”,“治疗” 之一.
class
字符串 - 这专精的职业, 如 "战士".
]]--

--[[ ==  GetNumSpecializations()  ==   返回可用专精的数量

  local numSpecializations = GetNumSpecializations(isInspect, isPet)

[] 可选参数


--参数--
isInspect
布尔值 - 如果为真(true), 返回已检查单位信息; 默认假(false)
isPet
布尔值 - 如果为真(true), 返回玩家宠物的信息; 默认假(false)

如果两参数都是假(false),函数返回关于玩家的信息.


--返回--
numSpecialization
数字 - 可用专精的数量.

]]--


--[[ ==  GetActiveSpecGroup()  ==   返回激活天赋组所在专精索引
返回专精索引 玩家当前激活的天赋组所在的

  local specGroup = GetActiveSpecGroup();

[] 可选参数


--参数--



--返回--
specGroup 
当前激活的天赋组的索引 (1 主要 / 2 次要). 好像总是1

--例子--

/script print(GetActiveSpecGroup())

]]--

--]]


--[[  天赋相关

--[[ ==  GetTalentInfo()  ==   返回天赋信息

  local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(tabIndex, talentIndex, talentGroup[, inspect])

[] 可选参数


--参数--
tabIndex
整型 - 指定选项卡的天赋包括在内.即第几层天赋
talentIndex
整型 - 指定天赋在给定的选项卡. 即当层第几个天赋
          注:talentIndex 是从左到右,自上而下. 
		  这意味着在第一行最左边的天赋是1,紧随其后右边的是2. 
		  如果右边没有其它天赋时下一行从左边的天赋继续.
talentGroup
数字 - 返回信息的专精组索引,默认1即可。	可用 GetActiveSpecGroup()获取	  
inspect
布尔值 - 如果为真(true)，返回已检查单位的信息,而不是玩家.
		  


--返回--
talentID
字符串 - 天赋 ID.
name
字符串 - 天赋的名称在该标签页,或零 如果没有天赋用这个选项卡/索引的组合.
texture
字符串 - 天赋图标的纹理路径,或零 如果没有天赋用这个选项卡/索引的组合.
selected
布尔值 - 真(true)如果天赋是选择了的, 否则为假(false).
available
布尔值 - 真(true)如果天赋是选择了的,或者是等级合适的玩家在这层没有选择天赋, 否则为假(false).
spellID
字符串 - 法术ID添加到法术书.
unknown
总是出现是零.
row
整型 - 行，天赋图标的垂直网格位置在其天赋窗格选项卡, 或1 如果没有天赋用这个选项卡/索引的组合.
column
整型 - 列，天赋图标的水平网格位置在其天赋窗格选项卡, 或1 如果没有天赋用这个选项卡/索引的组合.
known
布尔值 - 真(true)如果天赋是已知,否则为假(false), 似乎和selected一样


--例子--
显示每个天赋标签名称然后天赋名字和当前/最大等级在每个选项卡
local numTabs = GetNumTalentTabs();
for t=1, numTabs do
    DEFAULT_CHAT_FRAME:AddMessage(GetTalentTabInfo(t)..":");
    local numTalents = GetNumTalents(t);
    for i=1, numTalents do
        nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
        DEFAULT_CHAT_FRAME:AddMessage("- "..nameTalent..": "..currRank.."/"..maxRank);
    end
end

可获取指定天赋名称
local nameTalent= select(2, GetTalentInfo(2,1,1))print("Your current Talent:", nameTalent)

]]--


--[[ ==  GetNumTalents()  ==   返回一个选项卡(层)的天赋总数.
注:这包括学习和未学习的天赋.

  local numTalents = GetNumTalents(tabIndex);

[] 可选参数


--参数--
tabIndex
整型 - 指定选项卡用来计算的天赋总数.


--返回--
numTalents
整型 - 在选项卡中的天赋数量.

]]--


--[[ ==  GetNumTalentTabs()  ==   返回选项卡(层)数量.

  local numTabs = GetNumTalentTabs([inspect][,pet])

[] 可选参数


--参数--
inspect
布尔值 - 如果真(true)返回的信息是已检查单位而不是玩家.
pet
布尔值 - 如果真(true)返回的信息是已检查宠物而不是玩家. 


--返回--
numTabs
整型 - 选项卡(层)数量.

--例子-- 
显示一个天赋选项卡数量
local numTabs = GetNumTalentTabs()DEFAULT_CHAT_FRAME:AddMessage( numTabs )

]]--


--[[ ==  GetMaxTalentTier()  ==   返回可用的选项卡(层)数量.

  tiers = GetMaxTalentTier()

[] 可选参数


--参数--


--返回--
tiers
数字 - 可用的天赋层数玩家的角色,基于角色的等级

--例子-- 
显示一个可用的天赋选项卡数量
local tiers = GetMaxTalentTier()DEFAULT_CHAT_FRAME:AddMessage( tiers )

]]--

--]]






























